function Initialize()
	msDayNightSwitch = SKIN:GetMeasure('mDayNightSwitcher')
	msTempNow = SKIN:GetMeasure('mTempNow')
	msFeelsLike = SKIN:GetMeasure('mFeelsLike')
	msWindNow = SKIN:GetMeasure('mWindSpeed')
	msWindToday = SKIN:GetMeasure('mTodayWindSpeed')
	msWindTonight = SKIN:GetMeasure('mTonightWindSpeed')
	msWindTomorrow = SKIN:GetMeasure('mWindSpeedTomorrow')
	msWindAfter = SKIN:GetMeasure('mAfterWindSpeed')
	sUnits = SKIN:GetVariable('Units')
	msPressure = SKIN:GetMeasure('mPressureNow')
	msChange = SKIN:GetMeasure('mPressureChange')
end -- Initialize

function Update()
	SKIN:Bang("!DisableMeasure mLuaScript")
-- SET DAY OR NIGHT FORECAST
    if tonumber( msDayNightSwitch:GetStringValue() ) == 999 
	    then SKIN:Bang('!SetVariable "GroupToShow" "ToNight"') 
				SKIN:Bang('!SetOption "MtForecastIcon" "MeasureName" "mTonightIcon"') 
				SKIN:Bang('!SetOption "MtForecastIcon" "ToolTipTitle" "Forecast [mTonightDescription]"') 
		else SKIN:Bang('!SetVariable "GroupToShow" "Today"') 
				SKIN:Bang('!SetOption "MtForecastIcon" "MeasureName" "mTodayIcon"') 
				SKIN:Bang('!SetOption "MtForecastIcon" "ToolTipTitle" "Forecast [mTodayDescription]"') 
		end  	
-- GET TEMPERATURES
	GaugeTempNow = tonumber( msTempNow:GetStringValue() )
	GaugeFeelsLike = tonumber( msFeelsLike:GetStringValue() )
-- CONVERT TO CENTIGRADE 	
	if string.lower(sUnits) == "f" 
		then
			GaugeTempNow = round((5/9)*(GaugeTempNow-32))
			GaugeFeelsLike = round((5/9)*(GaugeFeelsLike-32)) 			
		end		
-- SET TEMPERATURE GAUGE VALUES TO PERCENTAGE OF -30 to +40 
	 SetMeterValue( 'MtTempPointer', ((GaugeTempNow+30)/70))	
	 SetMeterValue( 'MtFeelsPointer', ((GaugeFeelsLike+30)/70))		

-- SET WIND CLASSIFICATIONS
		if tonumber( msWindNow:GetStringValue()) > 0 then
				SKIN:Bang('!SetOption', 'MtWindIndicator', 'ToolTipText', windclass( tonumber( msWindNow:GetStringValue()))..' from#CRLF#the [mWindDirection] at [mWindSpeed] [mWindSpeedUnits]'	)	
		else
				SKIN:Bang('!SetOption', 'MtWindIndicator', 'ToolTipText', 'It is calm without any wind'	)	
		end		
		SKIN:Bang('!SetOption', 'DayWindSpeed', 'Text', windclass( tonumber( msWindToday:GetStringValue())))			
		SKIN:Bang('!SetOption', 'NightWindSpeed', 'Text', windclass( tonumber( msWindTonight:GetStringValue())))	
		SKIN:Bang('!SetOption', 'TomorrowWindSpeed', 'Text', windclass( tonumber( msWindTomorrow:GetStringValue())))	
		SKIN:Bang('!SetOption', 'AfterWindSpeed', 'Text', windclass( tonumber( msWindAfter:GetStringValue())))	
	
-- SET BAROMETER TEXT ( adapted from JSBarometer.lua by JSMorley )
		sCurrentPressure = msPressure:GetStringValue()
		sCurrentChange = msChange:GetStringValue()
		sCurrentDescription = "Pressure Leakage"
		if string.lower(sUnits) == "m" 
			then  InchesHg = round(tonumber(sCurrentPressure) / 33.8639, 2)
			else   InchesHg = round(tonumber(sCurrentPressure),2) 
		end		
				
	-- SET BAROMETER VALUE 		
		SetMeterValue( 'MtBarometer', round( (InchesHg*33.8639),0)  )					
		-- print("inches Hg : "..InchesHg.."   =   "..round( (InchesHg*33.8639),0).." millibars"  )			
		if InchesHg <= 28.59 then
			if sCurrentChange == "falling" then
				sCurrentDescription = "Increasingly Stormy"
			elseif sCurrentChange == "steady" then
				sCurrentDescription = "Rain and Stormy"
			elseif sCurrentChange == "rising" then
				sCurrentDescription = "Stormy but Improving"
			end
		end	
		if InchesHg >= 28.6 and InchesHg <= 29.59 then
			if sCurrentChange == "falling" then
				sCurrentDescription = "More rain likely"
			elseif sCurrentChange == "steady" then
				sCurrentDescription = "Rainy"
			elseif sCurrentChange == "rising" then
				sCurrentDescription = "Rainy but improving"
			end
		end
		if InchesHg >= 29.6 and InchesHg <= 30.09 then
			if sCurrentChange == "falling" then
				sCurrentDescription = "Changing to Rain"
			elseif sCurrentChange == "steady" then
				sCurrentDescription = "Steady between Rain and Fair"
			elseif sCurrentChange == "rising" then
				sCurrentDescription = "Changing to Fair"
			end
		end
		if InchesHg >= 30.1 and InchesHg <= 30.59 then
			if sCurrentChange == "falling" then
				sCurrentDescription = "Fair but Worsening"
			elseif sCurrentChange == "steady" then
				sCurrentDescription = "Fair"
			elseif sCurrentChange == "rising" then
				sCurrentDescription = "Fair and Improving"
			end
		end
		if InchesHg >= 30.6 then
			if sCurrentChange == "falling" then
				sCurrentDescription = "Very Dry, getting drier"
			elseif sCurrentChange == "steady" then
				sCurrentDescription = "Very Dry"
			elseif sCurrentChange == "rising" then
				sCurrentDescription = "Very Dry but improving"
			end		
		end
			SKIN:Bang("!SetOption MtBarometer ToolTipText \"Pressure [cSetPressureNow] mb #CRLF#"..sCurrentDescription.."\"")	
	return 'meters set'
end -- function Update

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function windclass(speed)
    local description = 'Calm' 
    if speed > 1 and speed <=5 then description = 'Light air' 
			elseif speed > 5 and speed <=11 then description = 'Light Breeze'  
			elseif speed > 11 and speed <=19 then description = 'Gentle Breeze'  
			elseif speed > 19 and speed <=28 then description = 'Moderate Breeze'  
			elseif speed > 29 and speed <=38 then description = 'Fresh Breeze'  
			elseif speed > 38 and speed <=49 then description = 'Strong Breeze'  
			elseif speed > 49 and speed <=61 then description = 'Moderate Gale'  
			elseif speed > 61 and speed <=74 then description = 'Fresh Gale'  
			elseif speed > 74 and speed <=88 then description = 'Strong Gale'  
			elseif speed > 88 and speed <=102 then description = 'Full Gale'  
			elseif speed > 102 and speed <=117 then description = 'Storm'  
			elseif speed > 117 then description = 'Hurricane'
	end 
	return description
end	

function SetMeterValue(Meter,Value)
   local mHandle=assert(SKIN:GetMeter(Meter),'Invalid Meter '..Meter)
   local MeasureName=assert(mHandle:GetOption('MeasureName'),'MeasureName not found in '..Meter)
   if assert(SKIN:GetMeasure(MeasureName),'Invalid Measure '..MeasureName) then
      SKIN:Bang('!SetOption',MeasureName,'Formula',Value)
      SKIN:Bang('!UpdateMeasure',MeasureName)
   end
end